/**
 * SearchResultEntry.java
 *
 * File generated from the core::SearchResultEntry uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.hpd;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;

import org.w3c.dom.Document;
import org.w3c.dom.Node;


/**
 * Description of the class SearchResultEntry.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "SearchResultEntry", propOrder = {
	"attr",
	"dn"
})
@XmlRootElement(name = "SearchResultEntry")
public class SearchResultEntry extends net.ihe.gazelle.hpd.DsmlMessage implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElement(name = "attr", namespace = "urn:oasis:names:tc:DSML:2:0:core")
	public List<net.ihe.gazelle.hpd.DsmlAttr> attr;
	@XmlAttribute(name = "dn", required = true)
	public java.lang.String dn;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return attr.
	 * @return attr
	 */
	public List<net.ihe.gazelle.hpd.DsmlAttr> getAttr() {
		if (attr == null) {
	        attr = new ArrayList<net.ihe.gazelle.hpd.DsmlAttr>();
	    }
	    return attr;
	}
	
	/**
	 * Set a value to attribute attr.
	 * @param attr.
	 */
	public void setAttr(List<net.ihe.gazelle.hpd.DsmlAttr> attr) {
	    this.attr = attr;
	}
	
	
	
	/**
	 * Add a attr to the attr collection.
	 * @param attr_elt Element to add.
	 */
	public void addAttr(net.ihe.gazelle.hpd.DsmlAttr attr_elt) {
	    this.getAttr().add(attr_elt);
	}
	
	/**
	 * Remove a attr to the attr collection.
	 * @param attr_elt Element to remove
	 */
	public void removeAttr(net.ihe.gazelle.hpd.DsmlAttr attr_elt) {
	    this.getAttr().remove(attr_elt);
	}
	
	/**
	 * Return dn.
	 * @return dn
	 */
	public java.lang.String getDn() {
	    return dn;
	}
	
	/**
	 * Set a value to attribute dn.
	 * @param dn.
	 */
	public void setDn(java.lang.String dn) {
	    this.dn = dn;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.hpd");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:oasis:names:tc:DSML:2:0:core", "SearchResultEntry").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(SearchResultEntry searchResultEntry, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (searchResultEntry != null){
   			net.ihe.gazelle.hpd.DsmlMessage.validateByModule(searchResultEntry, _location, cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.hpd.DsmlAttr attr: searchResultEntry.getAttr()){
					net.ihe.gazelle.hpd.DsmlAttr.validateByModule(attr, _location + "/attr[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
    	}
    }

}